import math, random, pygame
from Resources import *

class Particle:
    """The actual particles themseleves."""
    def __init__(self, x, y, angle, speed, gravity, lifetime,
                 spread, image, color, fade):
        self.angle = -angle * math.pi / 180
        self.speed = speed
        self.gravity = gravity
        self.newgravity = gravity
        self.lifetime = lifetime
        self.spread = spread
        
        if image == None:
            self.image = pygame.Surface((2, 2))
            self.image.fill(color)
            self.image = self.image.convert()
            self.image_rect = self.image.get_rect()
        else:
            self.image, self.image_rect = loadImage(image)
            self.image = self.image.convert_alpha()
            
        self.fade = fade
        self.newfade = fade
        self.x = x + (self.spread * random.random())
        self.y = y + (self.spread * random.random())
        
        self.image_rect = self.image_rect.move(self.x, self.y)
        screen = pygame.display.get_surface()
        screen.blit(self.image, self.image_rect)


    def update(self):
        if self.lifetime > 0:
            self.x = self.x + (math.cos(self.angle) * self.speed)
            self.y = self.y + (math.sin(self.angle) * self.speed) \
                     + self.newgravity
            self.image.set_alpha(255 - self.newfade)
            self.image_rect = self.image.get_rect()
            self.image_rect = self.image_rect.move(self.x, self.y)
            
            screen = pygame.display.get_surface()
            screen.blit(self.image, self.image_rect)
            
            self.newgravity += self.gravity
            self.newfade += self.fade
            if self.newfade <= 0:
                self.newfade = 0
            self.lifetime -= 1
            return True
        else:
            return False

            
if __name__ == "__main__":
    import sys
    pygame.init()
    size = width, height = 600, 600
    screen = pygame.display.set_mode(size)
    
    x = 300
    y = 300
    angle = 45
    speed = 1
    gravity = .02
    lifetime = 100
    spread = 0
    image = None
    color = (255, 255, 255, 255)
    fade = 2
    
    part = Particle(x, y, angle, speed, gravity, lifetime, spread, image, color, fade)
    
    background = pygame.Surface(screen.get_size())
    background.fill((0, 0, 0, 255))
    background = background.convert()
    
    clock = pygame.time.Clock()
    alive = True
    
    while True:
        for event in pygame.event.get():
            if event.type == pygame.KEYDOWN and event.key == pygame.K_ESCAPE:
                sys.exit()
        
        screen.blit(background, (0, 0))
        if alive:
            alive = part.update()
        pygame.display.flip()
        clock.tick(120)