import os, pygame

def loadImage(name):
    """Provide some error handling to image loading."""
    filename = os.path.join("data", name)
    try:
        image = pygame.image.load(filename)
        image_rect = image.get_rect()
    except pygame.error:
        print "Oops! Can't load image %s..." % (filename)
        raise SystemExit
    return image, image_rect

def loadSound(name):
    """Provide some error handling to sound loading."""
    class NoneSound:
        def play(self):
            pass
    if not pygame.mixer:
        return NoneSound()
        
    filename = os.path.join("data", name)
    try:
        sound = pygame.mixer.Sound(filename)
    except pygame.error:
        print "Oops! Can't load sound %s..." % (filename)
        raise SystemExit
    return sound
    
def loadMusic(name):
    """Provide some error handling to music loading."""
    filename = os.path.join("data", name)
    try:
        pygame.mixer.music.load(filename)
        pygame.mixer.music.set_volume(.25)
        pygame.mixer.music.play(-1)
    except pygame.error:
        print "Oops! Can't load music %s..." % (filename)
        raise SystemExit