import os, pygame

class Timer:
    """A class to keep track of time and draw the timer."""
    def __init__(self, seconds=75):
        self.startTime = pygame.time.get_ticks()
        self.maxTime = seconds * 1000
        self.timeLeft = self.maxTime
        self.currentTime = int(self.timeLeft / 1000)
        self.lastSeen = self.currentTime
        
        self.font = pygame.font.Font(os.path.join("data", "GlaserSteD.ttf"), 30)
        self.color = (0, 0, 0, 255)
        temp = str(self.currentTime / 60) + ":" + str(self.currentTime % 60)
        self.text = self.font.render(temp, 1, self.color)
        self.textLoc = self.text.get_rect()
        self.textLoc = self.textLoc.move((420, 0))
        
        self.screen = pygame.display.get_surface()
        self.screen.blit(self.text, self.textLoc)
        
    def update(self):
        currentTime = pygame.time.get_ticks()
        self.timeLeft = self.maxTime - currentTime + self.startTime
        
        if self.timeLeft <= 0:
            self.timeLeft = 0
        
        self.currentTime = int(self.timeLeft / 1000)
        
        if self.currentTime < self.lastSeen:
            self.lastSeen = self.currentTime
        
        temp = "%01i:%02i" % (int(self.currentTime / 60), int(self.currentTime % 60))
        self.text = self.font.render(temp, 1, self.color)
        self.screen.blit(self.text, self.textLoc)
        
    def getTime(self):
        return self.currentTime
        
    def getTimeTaken(self):
        return (self.maxTime - self.timeLeft) / 1000 + 1
        
    def getTimeScore(self):
        return (self.maxTime - self.timeLeft) / 1000.0 + 1.0    